/* s_sock.c  - Server for tcp-socket */

#include "inet.h"
int debug=0;

talk(sockfd)
int sockfd;
{ 
   long n,c,lgt,count,nlgt,ncount,ist=0;
   char sendline[65000];

   /* lesen laenge*/
   read(sockfd,&nlgt,sizeof(nlgt));
   write(sockfd,&nlgt,sizeof(nlgt));
   /* lesen Paketanzahl */
   read(sockfd,&ncount,sizeof(ncount));
   write(sockfd,&ncount,sizeof(ncount));
   lgt=ntohl(nlgt);
   count=ntohl(ncount);
   fprintf(stderr,"Paketgroesse: %d, Anzahl: %d\n",lgt,count);
   for (ist=0; ist<count; ist++){
      c=0;
      while( c < lgt ) {
         n=read(sockfd,&sendline[c],lgt-c);
         if( debug == 1) write(1,".",1);
	 if (n <= 0) {
	      fprintf(stderr,"error read: %d, gelesen: %d\n",n,c);
	      exit(1);
         }
	 c+=n;
      }
      if( (n=write(sockfd,&sendline,lgt)) != lgt) {
	   fprintf(stderr,"error write: %d\n", n);
	   exit(-1);
      }
      if( debug == 1) write(1,"-",1);
   }
   fprintf(stderr,"\nready\n");
}

main(argc,argv)
int argc;
char *argv[];
{
   int sockfd, newsockfd, clilen, childpid;
   struct sockaddr_in  cli_addr, serv_addr;
        int i;

   if (( sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      fprintf(stderr,"server: can't open stream socket\n");
      exit(-1);
        }
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   serv_addr.sin_port = htons(SERV_TCP_PORT);
   if ((i=bind(sockfd, (struct sockaddr *) &serv_addr,
                                    sizeof(serv_addr))) < 0){
      fprintf(stderr,
                   "server: can't bind local address: %d\n",i);
      exit(-2);
   }
/*next*/
   listen(sockfd,5);
   for (;;) {
      clilen = sizeof(cli_addr);
      newsockfd = 
         accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
      if  (newsockfd < 0){
         fprintf(stderr,"server: accept error\n");
         exit(-3);
      }
      if ((childpid = fork()) < 0) {
         fprintf(stderr,"server: fork error\n");
         exit(-4);
      }
      else if (childpid == 0) {
              close(sockfd);
              talk(newsockfd);
              exit(0);
           }
      close(newsockfd);
   }
}
